// Agent class
// CSC 375 - Lea
// Jacob Peck

// To be run on rho:
// java Agent

import java.util.*;
import java.net.*;
import java.io.*;
import java.util.concurrent.*;

public class Agent {
  private static boolean auto = false;
  private static boolean humanred = false;
  private static boolean humanblack = false;
  
  private static final ForkJoinPool fp = new ForkJoinPool();
  
  public static Socket socket;
  public static ObjectInputStream in;
  public static ObjectOutputStream out;
  
  private static final Board board = new Board(); // initialize board.
  
  public static void main(String[] args) {
    System.out.println("Initializing system...");
    try{
      System.out.println("Creating ServerSocket");
      ServerSocket ss = new ServerSocket(3553);
      System.out.println("Awaiting connection...");
      socket = ss.accept();
      System.out.println("Making OOS");
      out = new ObjectOutputStream(socket.getOutputStream());
      System.out.println("Making OIS");
      in = new ObjectInputStream(socket.getInputStream());

    } catch (Exception ex) {ex.printStackTrace(); System.exit(-1);}
    
    System.out.println("Connection established.");
    
    for(;;) {
      try{
        System.out.println("Waiting on object...");
        FindMove fm = null;
        fm = (FindMove)in.readObject(); 
        fp.invoke(fm);
        System.out.println("Received object, calculating...");
        int retval = fm.join();
        System.out.println("Returning: " + retval);
        out.writeInt(retval);
        out.flush();
      }
      catch (SocketException ex) {
        System.out.println("Connection interrupted, going down...");
        System.exit(0);
      }
      catch (IOException ex) {
        System.out.println("Connection interrupted, going down...");
        System.exit(0);
      }
      catch (Exception ex) {
        ex.printStackTrace();
        System.exit(-1);
      }
    }
  }
}
